/**
 * Title:           ResultSet, $Header: /share/gdi/SDI-Suite/Repository/projekte/BSH-GDI/genericViewer/src/main/java/de/conterra/bsh/gdi/gnviewer/datasources/ResultSet.java,v 1.2 2008/01/30 12:38:34 blume Exp $
 * Source:          $Source: /share/gdi/SDI-Suite/Repository/projekte/BSH-GDI/genericViewer/src/main/java/de/conterra/bsh/gdi/gnviewer/datasources/ResultSet.java,v $
 * created by:      Stefan Blume (blume)
 * erstellt am:     21.11.2007
 * Copyright:       con terra GmbH, 2005
 *
 * modified by:     $Author: blume $
 * modified on:     $Date: 2008/01/30 12:38:34 $
 * Version:         $Revision: 1.2 $
 * TAG:             $Name:  $
 * locked from:     $Locker:  $
 * CVS State:       $State: Exp $
 * Project:         $ProjectName$
 */
package de.intevation.gnv.geobackend.sde.datasources;

import org.apache.log4j.Logger;

/**
 * The class <code>ResultSet</code> fulfills the following purposes:
 * <ol>
 * <li>Providing an abstract object for dealing with result sets.</li>
 * </ol>
 *
 * @author blume
 * @version 1.0
 * @serial 1.0
 * @see
 * @since 21.11.2007 09:26:53
 */
public abstract class ResultSet {

    /**
     * Default Logging instance
     */
    private static Logger sLogger = Logger.getLogger(ResultSet.class);

    /**
     * Returns the number of hits.
     *
     * @return count of results.
     */
    public abstract int getCount();

    /**
     * Returns the number of columns returned through the query.
     *
     * @return the number of columns.
     */
    public abstract int getNumberOfColumns();

    /**
     * A ResultSet can tell about the concrete definition of each column.
     * This method returns an array of {@link de.conterra.bsh.gdi.gnviewer.datasources.ColDefinition}-Objects.
     *
     * @return the definitions describing the result set.
     */
    public abstract ColDefinition[] getColumnDefinitions();

    /**
     * Returns an array of Rows. The rows contain the "content" of the current ResultSet.
     *
     * @return the results itself.
     */
    public abstract Row[] getResults();

}
