/**
 * Title:           SDEResultSet, $Header: /share/gdi/SDI-Suite/Repository/projekte/BSH-GDI/genericViewer/src/main/java/de/conterra/bsh/gdi/gnviewer/datasources/sde/SDEResultSet.java,v 1.2 2008/01/30 12:38:34 blume Exp $
 * Source:          $Source: /share/gdi/SDI-Suite/Repository/projekte/BSH-GDI/genericViewer/src/main/java/de/conterra/bsh/gdi/gnviewer/datasources/sde/SDEResultSet.java,v $
 * created by:      Stefan Blume (blume)
 * erstellt am:     21.11.2007
 * Copyright:       con terra GmbH, 2005
 *
 * modified by:     $Author: blume $
 * modified on:     $Date: 2008/01/30 12:38:34 $
 * Version:         $Revision: 1.2 $
 * TAG:             $Name:  $
 * locked from:     $Locker:  $
 * CVS State:       $State: Exp $
 * Project:         $ProjectName$
 */
package de.intevation.gnv.geobackend.sde.datasources;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.apache.log4j.Logger;

/**
 * @author blume
 * @version 1.0
 * @serial 1.0
 * @see
 * @since 21.11.2007 11:01:27
 */
public class SDEResultSet extends ResultSet {

    /**
     * Default Logging instance
     */
    private static Logger sLogger = Logger.getLogger(SDEResultSet.class);


    private List<Row> mRows = Collections.synchronizedList(new ArrayList<Row>());
    private List<ColDefinition> mCols = Collections.synchronizedList(new ArrayList<ColDefinition>());

    public SDEResultSet() {
    }

    public int getCount() {
        return mRows.size();
    }

    public int getNumberOfColumns() {
        return mCols.size();
    }

    public ColDefinition[] getColumnDefinitions() {
        ColDefinition[] lColDefinitions = new ColDefinition[mCols.size()];
        return mCols.toArray(lColDefinitions);
    }

    public Row[] getResults() {
        Row[] lRows = new Row[mRows.size()];
        return mRows.toArray(lRows);
    }

    public void addRow(Row pRow) {
        mRows.add(pRow);
    }

    public void addCol(ColDefinition pColDefinition) {
        mCols.add(pColDefinition);
    }

}
